﻿using System;
using System.Collections.Generic;

namespace TSLab.Script.Handlers
{
    //[HandlerCategory("Indicators")]
    public class AroonUp : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public static double Highest(IList<double> candles, int curbar, int period)
        {
            double high = Double.MinValue;
            int num = 0;
            int start = curbar - period + 1;
            if (start < 0)
            {
                start = 0;
            }
            for (int i = curbar; i >= start; i--)
            {
                if(high < candles[i])
                {
                    high = candles[i];
                    num = i;
                }
            }
            return curbar - num;
        }

        public IList<double> Execute(IList<double> source)
        {
            var res = new double[source.Count];
            for (int i = 1; i < source.Count; i++)
            {
                var d = Highest(source, i, Period);
                res[i] = 100 * (Period - d) / Period;
            }
            return res;
        }
    }

    //[HandlerCategory("Indicators")]
    public class AroonDown : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public static double Lowest(IList<double> candles, int curbar, int period)
        {
            double low = Double.MaxValue;
            int num = 0;
            int start = curbar - period + 1;
            if (start < 0)
            {
                start = 0;
            }
            for (int i = curbar; i >= start; i--)
            {
                if (low > candles[i])
                {
                    low = candles[i];
                    num = i;
                }
            }
            return curbar - num;
        }

        public IList<double> Execute(IList<double> source)
        {
            var res = new double[source.Count];
            for (int i = 1; i < source.Count; i++)
            {
                var d = Lowest(source, i, Period);
                res[i] = 100 * (Period - d) / Period;
            }
            return res;
        }
    }
}
