﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TSLab.Script.Handlers
{
    public class DrowdownCount : IOneSourceHandler, IDoubleReturns, IValuesHandler, ISecurityInputs
    {
        public double Execute(ISecurity source, int barNum)
        {
            return (from pos in source.Positions.OrderByDescending(pos => pos.ExitBarNum)
                    where !pos.IsActive
                    select pos.Profit()).TakeWhile(profit => profit <= 0).Count();
        }
    }
}
