﻿using System.Collections.Generic;
using TSLab.Script.Helpers;

namespace TSLab.Script.Handlers
{
    //[HandlerCategory("Indicators")]
    public class TEMA : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public IList<double> Execute(IList<double> source)
        {
            var ema1 = Series.EMA(source, Period);
            var ema2 = Series.EMA(ema1, Period);
            var ema3 = Series.EMA(ema2, Period);
            var res = new double[source.Count];
            for (int i = 0; i < source.Count; i++)
            {
                res[i] = 3 * ema1[i] - 3 * ema2[i] + ema3[i];
            }
            return res;
        }
    }

    //[HandlerCategory("Indicators")]
    public class DEMA : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public IList<double> Execute(IList<double> source)
        {
            var ema1 = Series.EMA(source, Period);
            var ema2 = Series.EMA(ema1, Period);
            var res = new double[source.Count];
            for (int i = 0; i < source.Count; i++)
            {
                res[i] = 2 * ema1[i] - ema2[i];
            }
            return res;
        }
    }
}
