﻿using System.Collections.Generic;
using TSLab.Script.Helpers;

namespace TSLab.Script.Handlers
{
    //[HandlerCategory("Indicators")]
    public class TRIX : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public IList<double> Execute(IList<double> source)
        {
            var ema1 = Series.EMA(source, Period);
            var ema2 = Series.EMA(ema1, Period);
            var ema3 = Series.EMA(ema2, Period);
            var res = new double[source.Count];
            for(int i = 1; i < source.Count; i++)
            {
                var d = ema3[i - 1];
                res[i] = d == 0 ? 0 : (ema3[i] - d)/d;
            }
            return res;
        }
    }
}
